import java.io.*;

class TryWithResources {
	static void mean(String eingabe) {
		try (DataInputStream dis = new DataInputStream(new FileInputStream(eingabe))) {
			double sum = 0.0;
			int n = 0;
			while (dis.available() > 0) {
				n++;
				sum += dis.readDouble();
			}
			System.out.println("Mittelwert zur Datei " + eingabe + ":  " + sum/n);
		} catch (IOException ioe) {
			System.out.println(ioe);
		}
	}

	static void createData(String eingabe) {
			DataOutputStream dos = null;
			try {
				dos = new DataOutputStream(new FileOutputStream(eingabe));
				java.util.Random ran = new java.util.Random();
				for (int i = 1; i <= 100; i++)
					dos.writeDouble(ran.nextDouble());
			} catch (IOException ioe) {
				System.out.println(ioe.getMessage());
			} finally {
				if (dos != null)
					try {dos.close();} catch (IOException ignored) {};
			}
	}
	
	public static void main(String args[]) {
		createData("eingabe.dat");	
		mean("eingabe.dat");
	}
}
