class Fakul {
	static int convertInput(String instr) throws IllegalArgumentException {
		int arg;
		try {
			arg = Integer.parseInt(instr);
			if (arg < 0  || arg > 170)
				throw new IllegalArgumentException(
						"Unzulässiges Argument (erlaubt: 0 bis 170): " + arg);
			else
				return arg;
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException("Fehler beim Konvertieren: " + instr, e);
		}
	}

	public static void main(String args[]) {
		int argument = -1;
		try {
			if (args.length == 0)
				throw new IllegalArgumentException ("Kein Argument angegeben");
			argument = convertInput(args[0]);
		} catch (IllegalArgumentException iae) {
			System.out.println(iae.getMessage());
			if (iae.getCause() != null)
				System.out.println(" Ursache: " + iae.getCause().getMessage());
			System.exit(1);
		}
		double fakul = 1.0;
		for (int i = 1; i <= argument; i++)
			fakul = fakul * i;
		System.out.println("Fakultät von " + argument + ": " + fakul);
	}
}
