// Das Programm demonstriert die Verwendung der Klassen FileInputStream und FileOutputStream.
// Zum Erstellen einer Dateikopie in Java 7 sollte man jedoch eine copy()-Methode der Klasse Files verwenden.

import java.io.*;

class FileCopy {
	final static String QUELLE = "quelle.dat", ZIEL = "ziel.dat";
	final static int BUFLEN = 1048576; // Ein Megabyte (1024*1024 Bytes) als Puffergröße

	public static void main(String[] args) {
		byte[] buffer = new byte[BUFLEN];
		int nread;
		long zeit, total = 0;
		try (FileInputStream  fis = new FileInputStream(QUELLE);
			 FileOutputStream fos = new FileOutputStream(ZIEL)) {
//		try (BufferedInputStream  fis = new BufferedInputStream(new FileInputStream(QUELLE));
//			 BufferedOutputStream  fos = new BufferedOutputStream(new FileOutputStream(ZIEL))) {
			zeit = System.currentTimeMillis();
			System.out.println("Kopieren von " + QUELLE + " in " + ZIEL +  " gestartet:");
			while (true) {
				nread = fis.read(buffer, 0, Math.min(BUFLEN, fis.available()));
				if (nread == 0)
					break;
				else {
					fos.write(buffer, 0, nread);
					total += nread;
					System.out.print("*");
				}
			}
			zeit = System.currentTimeMillis() - zeit;
			System.out.println("\nEs wurden " + total + " Bytes kopiert. "+
					"(Benötigte Zeit: " + zeit + " Millisekunden.)");
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
	}
}