import java.io.*;

class BufferedOutputStreamFile {
	final static long ANZAHL = 10_000;
//	final static String AUSGABE = "V:\\U-Laufwerk\\ifsp\\Weg\\Ausgabe.dat";
	final static String AUSGABE = "Ausgabe.dat";

	public static void main(String[] args) {
		long time;

		try (FileOutputStream fos = new FileOutputStream(AUSGABE)) {
			time = System.currentTimeMillis();
			for (int i = 1; i <= ANZAHL; i++)
				fos.write(i);
			System.out.println("Zeit für die ungepufferte Ausgabe: " +
					(System.currentTimeMillis() - time));
		} catch (IOException ioe) {
			System.err.println(ioe);
			System.exit(1);
		}
		
		try (BufferedOutputStream bos = new BufferedOutputStream(
                                        new FileOutputStream(AUSGABE))) {
			time = System.currentTimeMillis();
			for (int i = 1; i <= ANZAHL; i++)
				bos.write(i);
			System.out.println("Zeit für die gepufferte Ausgabe:   " +
					(System.currentTimeMillis() - time));
		} catch (IOException ioe) {
			System.err.println(ioe);
		}
	}
}