import java.io.*;
import java.nio.file.*;

class BufferedWriterDemo {
	final static int ANZAHL = 20_000_000;

	static void ohneBufferedWriter() throws IOException {
		for (int i = 0; i < 2; i++) {
			try (FileWriter fw = new FileWriter("test.txt")) {
				long time = System.currentTimeMillis();
				for (int j = 1; j <= ANZAHL; j++)
					fw.write("Zeile " + i + System.lineSeparator());
				if (i == 1)
					System.out.println("Benötigte Zeit ohne BufferedWriter:        "
						+ (System.currentTimeMillis() - time));
			}
			Files.delete(Paths.get("test.txt"));
		}
	}

	static void mitBufferedWriter() throws IOException {
		for (int i = 0; i < 2; i++) {
			try (BufferedWriter bw = new BufferedWriter(new FileWriter("test.txt"))) {
				long time = System.currentTimeMillis();
				for (int j = 1; j <= ANZAHL; j++)
					bw.write("Zeile " + i + System.lineSeparator());
				if (i == 1)
					System.out.println("Benötigte Zeit mit BufferedWriter:         "
						+ (System.currentTimeMillis() - time));
			}
			Files.delete(Paths.get("test.txt"));
		}
	}

	public static void main(String[] args) throws IOException {
		mitBufferedWriter();
		ohneBufferedWriter();
	}
}