import java.io.*;
import java.nio.file.*;

class OutputStreamWriterDemo {
	public static void main(String[] args) throws IOException {
		String[] encodings = {"ASCII", "ISO8859_1", "UTF8",
		                      "UnicodeBigUnmarked", "UnicodeLittleUnmarked",
		                      "Cp1252", "Cp850"};
		Files.deleteIfExists(Paths.get("test.txt"));
		for (int i = 0; i < encodings.length; i++) {
			try (OutputStreamWriter osw = new OutputStreamWriter(
					                  new FileOutputStream("test.txt", true), encodings[i])) {
				osw.write(encodings[i] + " ae = ä" + System.lineSeparator());
			}
		}
	}
}
