package de.zimk.attendance;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;
import javafx.stage.Stage;
import java.util.Comparator;

public class Attendance extends Application {
    private double dist = 10.0;

    @Override
    public void start(Stage primaryStage) {
        // Demonstrationsfälle
        String[] anwesend = new String[] {"Willi", "Otto", "Theo", "Irma", "Doro", "Heiner", "Michael", "Ludger", "Ben"};

        ObservableList<String> peple = FXCollections.observableArrayList(anwesend);
        SortedList<String> perSorted = new SortedList<>(peple, Comparator.naturalOrder());
        ListView<String> lvPeople = new ListView<>(perSorted);

        GridPane root = new GridPane();
        root.setPadding(new Insets(dist, dist, dist, dist));
        root.setHgap(dist); root.setVgap(dist);

        Label lblName = new Label("Name:");
        Label lblPresent = new Label("Anwesend:");
        TextField tfName = new TextField();

        Button btnAdd = new Button("Angekommen");
        btnAdd.setOnAction(event -> {
            String s = tfName.getText();
            if (s.length() > 0  &&  !peple.contains(s))
                peple.add(s);
        });

        Button btnRemove = new Button("Gegangen");
        btnRemove.setOnAction(event ->
                peple.remove(lvPeople.getSelectionModel().getSelectedItem()));

        root.add(lblName, 0, 0); root.add(tfName, 1, 0); root.add(btnAdd, 2, 0);
        root.add(lblPresent, 0, 1); root.add(lvPeople, 1, 1); root.add(btnRemove, 2, 1);

        GridPane.setVgrow(lvPeople, Priority.ALWAYS);
        GridPane.setHgrow(tfName, Priority.ALWAYS);

//        root.setGridLinesVisible(true);
        primaryStage.setTitle("Anwesenheitskontrolle");
        primaryStage.setScene(new Scene(root, 450, 200));
        primaryStage.setMinWidth(400);
        primaryStage.setMinHeight(150);
        primaryStage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
