import javafx.beans.property.*;

public class Person {
	private static int count = 0;
	private ReadOnlyIntegerWrapper id = new ReadOnlyIntegerWrapper(this, "id", ++count);
	private StringProperty firstName = new SimpleStringProperty(this, "firstName", "");
	private StringProperty lastName = new SimpleStringProperty(this, "lastName", "");
	private IntegerProperty age = new SimpleIntegerProperty(this, "age", -99);

	public Person(String first, String last, int a) {
		firstName.setValue(first);
		lastName.setValue(last);
		age.setValue(a);
	}

	public final int getId() {
		return id.get();
	}
	public final ReadOnlyIntegerProperty idProperty() {
		return id.getReadOnlyProperty();
	}


	public final String getFirstName() {
		return firstName.get();
	}
	public final void setFirstName(String first) {
		firstName.set(first);
	}
	public final StringProperty firstNameProperty() {
		return firstName;
	}


	public final String getLastName() {
		return lastName.get();
	}
	public final void setLastName(String last) {
		lastName.set(last);
	}
	public final StringProperty lastNameProperty() {
		return lastName;
	}


	public final int getAge() {
		return age.get();
	}
	public final void setAge(int a) {
		age.set(a);
	}
	public final IntegerProperty ageProperty() {
		return age;
	}
}
