import java.math.BigDecimal;
import java.util.stream.IntStream;

class FactorialByParallelStream {
	public static void main(String[] args) {
		int argument = 50_000;
		long zeit;
		BigDecimal ergebnis;

		// Fakultätsberechnung durch einen parallelen Strom
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = IntStream
					.rangeClosed(1, argument)
					.parallel()
					.mapToObj(BigDecimal::new)
					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
			System.out.printf("\nLaufzeit mit parallelem Strom in Millisekunden:" +
							"%7d (Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
		}

//		// Fakultät mit einem seriellen Strom
//		System.out.println("\n");
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = IntStream
//					.rangeClosed(1, argument)
//					.mapToObj(BigDecimal::new)
//					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
//			System.out.printf("\nLaufzeit mit seriellem Strom in Millisekunden:%7d (Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
//		}
	}
}
