import java.math.BigDecimal;
import java.util.stream.IntStream;

class ForkJoinTest {
	static BigDecimal product(int start, int ende) {
		BigDecimal fac = new BigDecimal(start);
		for (int i = start+1; i <= ende; i++)
			fac = fac.multiply(new BigDecimal(i));
		return fac;
	}

	public static void main(String[] args) {
		int argument = 50_000;
		int schwelle = 100;
		long zeit;
		BigDecimal ergebnis;

		// Einmalige Berechnung der Fakultät per Fork-Join - Framework mit automatischer Schwelle
//		zeit = System.currentTimeMillis();
//		ergebnis = FacForkJoin.factorial(argument);
//		System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:%7d Ergebnis: %e)",
//				(System.currentTimeMillis()-zeit), ergebnis);

		// 5-malige Berechnung der Fakultät per Fork-Join - Framework mit manueller Schwelle
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = FacForkJoin.factorial(argument, schwelle);
//			System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:%7d (Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
//		}		

		//  5-malige Berechnung der Fakultät per Fork-Join - Framework (automatische Schwellenberechnung)
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = FacForkJoin.factorial(argument);
			System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:%7d (Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
		}

		//  5-malige Berechnung der Fakultät durch den main-Thread
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = product(1, argument);
			System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:%7d (Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
		}

//		//  5-malige Berechnung der Fakultät per Fork-Join (Single-Thread; Aufgabenaufteilung wird durch den Schwellenwert verhindert)
//		System.out.println("\n");
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = FacForkJoin.factorial(argument, 100_000);
//			System.out.printf("\nLaufzeit Single-Thread in Millisekunden:%7d (Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
//		}


//		// Fakultät mit einem parallelen Strom
//		System.out.println("\n");
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = IntStream
//					.rangeClosed(1, argument)
//					.parallel()
//					.mapToObj(BigDecimal::new)
//					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
//			System.out.printf("\nLaufzeit mit parallelem Strom in Millisekunden:\t%d \t(Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
//		}
//
//		// Fakultät mit einem seriellen Strom
//		System.out.println("\n");
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = IntStream
//					.rangeClosed(1, argument)
//					.mapToObj(BigDecimal::new)
//					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
//			System.out.printf("\nLaufzeit mit seriellem Strom in Millisekunden:\t%d \t(Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
//		}
	}
}
