import java.util.concurrent.*;

class ScheduledThreadPoolExecutorDemo {
	public static void main(String[] args) {
		ScheduledThreadPoolExecutor es = new ScheduledThreadPoolExecutor(2);
		es.scheduleAtFixedRate(new ScheduledRunner(1, es),
				0, 1000, TimeUnit.MILLISECONDS);
		es.scheduleAtFixedRate(new ScheduledRunner(2, es),
				2000, 2000, TimeUnit.MILLISECONDS);
		es.scheduleAtFixedRate(new ScheduledRunner(3, es),
				3000, 3000, TimeUnit.MILLISECONDS);
		try {Thread.sleep(5000);
		} catch (InterruptedException ignored) {Thread.currentThread().interrupt();}
		es.shutdown();
	}
}

class ScheduledRunner implements Runnable {
	private int nr;
	private ScheduledThreadPoolExecutor es;

	public ScheduledRunner(int nr, ScheduledThreadPoolExecutor es) {
		this.nr = nr;
		this.es = es;
	}

	private String formZeit() {
		return java.text.DateFormat.getTimeInstance().format(new java.util.Date());
	}

	public void run() {
		System.out.println("ScheduledRunner " + nr + ", Zeit: " + formZeit() +
				", Aktive Pool-Threads: " + es.getActiveCount());
		try {Thread.sleep(500*nr);
		} catch (InterruptedException ignored) {Thread.currentThread().interrupt();}
	}
}