package de.zimk.matrain.br;
import de.zimk.util.conio.Simput;

public class Bruch {
    private int zaehler;    // wird automatisch mit 0 initialisiert
    private int nenner = 1;

    public void setzeZaehler(int z) {
        zaehler = z;
    }

    public boolean setzeNenner(int n) {
        if (n != 0) {
            nenner = n;
            return true;
        } else
            return false;
    }

    public int gibZaehler() {
        return zaehler;
    }

    public int gibNenner() {
        return nenner;
    }

    public void kuerze() {
        // Größten gemeinsamen Teiler mit dem Euklidischen Algorithmus bestimmen
        if (zaehler != 0) {
            int ggt = 0;
            int az = Math.abs(zaehler);
            int an = Math.abs(nenner);
            do {
                if (az == an)
                    ggt = az;
                else if (az > an)
                    az = az - an;
                else
                    an = an - az;
            } while (ggt == 0);
            zaehler /= ggt;
            nenner /= ggt;
        } else
            nenner = 1;
    }

    public void addiere(Bruch b) {
        zaehler = zaehler * b.nenner + b.zaehler * nenner;
        nenner = nenner * b.nenner;
        kuerze();
    }

    public void frage() {
        int n;
        do {
            System.out.print("Zaehler: ");
            setzeZaehler(Simput.gint());
        } while (Simput.checkError());
        do {
            System.out.print("Nenner : ");
            // Bei irregulärer Eingabe liefert gint() eine 0 und setzt einen Fehlerindikator.
            n = Simput.gint();
            if (n == 0 && !Simput.checkError())
                System.out.println("Der Nenner darf nicht Null werden!\n");
        } while (n == 0);
        setzeNenner(n);
    }

    public void zeige() {
        System.out.printf("   %d\n -----\n   %d\n", zaehler, nenner);
    }
}

